#ifndef JLexer_h
#define JLexer_h
/*
 * D L G L e x e r  C l a s s  D e f i n i t i o n
 *
 * Generated from: parser.dlg
 *
 * 1989-2001 by  Will Cohen, Terence Parr, and Hank Dietz
 * Purdue University Electrical Engineering
 * DLG Version 1.33MR33
 */


#include "DLexerBase.h"

class JLexer : public DLGLexerBase {
public:
public:
	static const int MAX_MODE;
	static const int DfaStates;
	static const int START;
	static const int COMMENT_LINE;
	static const int COMPREPRO_LINE;
	static const int COMMENT_MULTI;
	static const int CONST_STRING;
	static const int CONST_CHAR;
	typedef unsigned short DfaState;

	JLexer(DLGInputStream *in,
		unsigned bufsize=2000)
		: DLGLexerBase(in, bufsize, 0)
	{
	;
	}
	void	  mode(int);
	ANTLRTokenType nextTokenType(void);
	void     advance(void);
protected:
	ANTLRTokenType act1();
	ANTLRTokenType act2();
	ANTLRTokenType act3();
	ANTLRTokenType act4();
	ANTLRTokenType act5();
	ANTLRTokenType act6();
	ANTLRTokenType act7();
	ANTLRTokenType act8();
	ANTLRTokenType act9();
	ANTLRTokenType act10();
	ANTLRTokenType act11();
	ANTLRTokenType act12();
	ANTLRTokenType act13();
	ANTLRTokenType act14();
	ANTLRTokenType act15();
	ANTLRTokenType act16();
	ANTLRTokenType act17();
	ANTLRTokenType act18();
	ANTLRTokenType act19();
	ANTLRTokenType act20();
	ANTLRTokenType act21();
	ANTLRTokenType act22();
	ANTLRTokenType act23();
	ANTLRTokenType act24();
	ANTLRTokenType act25();
	ANTLRTokenType act26();
	ANTLRTokenType act27();
	ANTLRTokenType act28();
	ANTLRTokenType act29();
	ANTLRTokenType act30();
	ANTLRTokenType act31();
	ANTLRTokenType act32();
	ANTLRTokenType act33();
	ANTLRTokenType act34();
	ANTLRTokenType act35();
	ANTLRTokenType act36();
	ANTLRTokenType act37();
	ANTLRTokenType act38();
	ANTLRTokenType act39();
	ANTLRTokenType act40();
	ANTLRTokenType act41();
	ANTLRTokenType act42();
	ANTLRTokenType act43();
	ANTLRTokenType act44();
	ANTLRTokenType act45();
	ANTLRTokenType act46();
	ANTLRTokenType act47();
	ANTLRTokenType act48();
	ANTLRTokenType act49();
	ANTLRTokenType act50();
	ANTLRTokenType act51();
	ANTLRTokenType act52();
	ANTLRTokenType act53();
	ANTLRTokenType act54();
	ANTLRTokenType act55();
	ANTLRTokenType act56();
	ANTLRTokenType act57();
	ANTLRTokenType act58();
	ANTLRTokenType act59();
	ANTLRTokenType act60();
	ANTLRTokenType act61();
	ANTLRTokenType act62();
	ANTLRTokenType act63();
	ANTLRTokenType act64();
	ANTLRTokenType act65();
	ANTLRTokenType act66();
	ANTLRTokenType act67();
	ANTLRTokenType act68();
	ANTLRTokenType act69();
	ANTLRTokenType act70();
	ANTLRTokenType act71();
	ANTLRTokenType act72();
	ANTLRTokenType act73();
	ANTLRTokenType act74();
	ANTLRTokenType act75();
	ANTLRTokenType act76();
	ANTLRTokenType act77();
	ANTLRTokenType act78();
	ANTLRTokenType act79();
	ANTLRTokenType act80();
	ANTLRTokenType act81();
	ANTLRTokenType act82();
	ANTLRTokenType act83();
	ANTLRTokenType act84();
	ANTLRTokenType act85();
	ANTLRTokenType act86();
	ANTLRTokenType act87();
	ANTLRTokenType act88();
	ANTLRTokenType act89();
	ANTLRTokenType act90();
	ANTLRTokenType act91();
	ANTLRTokenType act92();
	ANTLRTokenType act93();
	ANTLRTokenType act94();
	ANTLRTokenType act95();
	ANTLRTokenType act96();
	ANTLRTokenType act97();
	ANTLRTokenType act98();
	ANTLRTokenType act99();
	ANTLRTokenType act100();
	ANTLRTokenType act101();
	ANTLRTokenType act102();
	ANTLRTokenType act103();
	ANTLRTokenType act104();
	ANTLRTokenType act105();
	ANTLRTokenType act106();
	ANTLRTokenType act107();
	ANTLRTokenType act108();
	ANTLRTokenType act109();
	ANTLRTokenType act110();
	ANTLRTokenType act111();
	ANTLRTokenType act112();
	ANTLRTokenType act113();
	ANTLRTokenType act114();
	ANTLRTokenType act115();
	ANTLRTokenType act116();
	ANTLRTokenType act117();
	ANTLRTokenType act118();
	ANTLRTokenType act119();
	ANTLRTokenType act120();
	ANTLRTokenType act121();
	ANTLRTokenType act122();
	ANTLRTokenType act123();
	ANTLRTokenType act124();
	ANTLRTokenType act125();
	ANTLRTokenType act126();
	ANTLRTokenType act127();
	ANTLRTokenType act128();
	ANTLRTokenType act129();
	ANTLRTokenType act130();
	ANTLRTokenType act131();
	ANTLRTokenType act132();
	ANTLRTokenType act133();
	ANTLRTokenType act134();
	ANTLRTokenType act135();
	ANTLRTokenType act136();
	ANTLRTokenType act137();
	ANTLRTokenType act138();
	ANTLRTokenType act139();
	ANTLRTokenType act140();
	static DfaState st0[65];
	static DfaState st1[65];
	static DfaState st2[65];
	static DfaState st3[65];
	static DfaState st4[65];
	static DfaState st5[65];
	static DfaState st6[65];
	static DfaState st7[65];
	static DfaState st8[65];
	static DfaState st9[65];
	static DfaState st10[65];
	static DfaState st11[65];
	static DfaState st12[65];
	static DfaState st13[65];
	static DfaState st14[65];
	static DfaState st15[65];
	static DfaState st16[65];
	static DfaState st17[65];
	static DfaState st18[65];
	static DfaState st19[65];
	static DfaState st20[65];
	static DfaState st21[65];
	static DfaState st22[65];
	static DfaState st23[65];
	static DfaState st24[65];
	static DfaState st25[65];
	static DfaState st26[65];
	static DfaState st27[65];
	static DfaState st28[65];
	static DfaState st29[65];
	static DfaState st30[65];
	static DfaState st31[65];
	static DfaState st32[65];
	static DfaState st33[65];
	static DfaState st34[65];
	static DfaState st35[65];
	static DfaState st36[65];
	static DfaState st37[65];
	static DfaState st38[65];
	static DfaState st39[65];
	static DfaState st40[65];
	static DfaState st41[65];
	static DfaState st42[65];
	static DfaState st43[65];
	static DfaState st44[65];
	static DfaState st45[65];
	static DfaState st46[65];
	static DfaState st47[65];
	static DfaState st48[65];
	static DfaState st49[65];
	static DfaState st50[65];
	static DfaState st51[65];
	static DfaState st52[65];
	static DfaState st53[65];
	static DfaState st54[65];
	static DfaState st55[65];
	static DfaState st56[65];
	static DfaState st57[65];
	static DfaState st58[65];
	static DfaState st59[65];
	static DfaState st60[65];
	static DfaState st61[65];
	static DfaState st62[65];
	static DfaState st63[65];
	static DfaState st64[65];
	static DfaState st65[65];
	static DfaState st66[65];
	static DfaState st67[65];
	static DfaState st68[65];
	static DfaState st69[65];
	static DfaState st70[65];
	static DfaState st71[65];
	static DfaState st72[65];
	static DfaState st73[65];
	static DfaState st74[65];
	static DfaState st75[65];
	static DfaState st76[65];
	static DfaState st77[65];
	static DfaState st78[65];
	static DfaState st79[65];
	static DfaState st80[65];
	static DfaState st81[65];
	static DfaState st82[65];
	static DfaState st83[65];
	static DfaState st84[65];
	static DfaState st85[65];
	static DfaState st86[65];
	static DfaState st87[65];
	static DfaState st88[65];
	static DfaState st89[65];
	static DfaState st90[65];
	static DfaState st91[65];
	static DfaState st92[65];
	static DfaState st93[65];
	static DfaState st94[65];
	static DfaState st95[65];
	static DfaState st96[65];
	static DfaState st97[65];
	static DfaState st98[65];
	static DfaState st99[65];
	static DfaState st100[65];
	static DfaState st101[65];
	static DfaState st102[65];
	static DfaState st103[65];
	static DfaState st104[65];
	static DfaState st105[65];
	static DfaState st106[65];
	static DfaState st107[65];
	static DfaState st108[65];
	static DfaState st109[65];
	static DfaState st110[65];
	static DfaState st111[65];
	static DfaState st112[65];
	static DfaState st113[65];
	static DfaState st114[65];
	static DfaState st115[65];
	static DfaState st116[65];
	static DfaState st117[65];
	static DfaState st118[65];
	static DfaState st119[65];
	static DfaState st120[65];
	static DfaState st121[65];
	static DfaState st122[65];
	static DfaState st123[65];
	static DfaState st124[65];
	static DfaState st125[65];
	static DfaState st126[65];
	static DfaState st127[65];
	static DfaState st128[65];
	static DfaState st129[65];
	static DfaState st130[65];
	static DfaState st131[65];
	static DfaState st132[65];
	static DfaState st133[65];
	static DfaState st134[65];
	static DfaState st135[65];
	static DfaState st136[65];
	static DfaState st137[65];
	static DfaState st138[65];
	static DfaState st139[65];
	static DfaState st140[65];
	static DfaState st141[65];
	static DfaState st142[65];
	static DfaState st143[65];
	static DfaState st144[65];
	static DfaState st145[65];
	static DfaState st146[65];
	static DfaState st147[65];
	static DfaState st148[65];
	static DfaState st149[65];
	static DfaState st150[65];
	static DfaState st151[65];
	static DfaState st152[65];
	static DfaState st153[65];
	static DfaState st154[65];
	static DfaState st155[65];
	static DfaState st156[65];
	static DfaState st157[65];
	static DfaState st158[65];
	static DfaState st159[65];
	static DfaState st160[65];
	static DfaState st161[65];
	static DfaState st162[65];
	static DfaState st163[65];
	static DfaState st164[65];
	static DfaState st165[65];
	static DfaState st166[65];
	static DfaState st167[65];
	static DfaState st168[65];
	static DfaState st169[65];
	static DfaState st170[65];
	static DfaState st171[65];
	static DfaState st172[65];
	static DfaState st173[65];
	static DfaState st174[65];
	static DfaState st175[65];
	static DfaState st176[65];
	static DfaState st177[65];
	static DfaState st178[65];
	static DfaState st179[65];
	static DfaState st180[65];
	static DfaState st181[65];
	static DfaState st182[65];
	static DfaState st183[65];
	static DfaState st184[65];
	static DfaState st185[65];
	static DfaState st186[65];
	static DfaState st187[65];
	static DfaState st188[65];
	static DfaState st189[65];
	static DfaState st190[65];
	static DfaState st191[65];
	static DfaState st192[65];
	static DfaState st193[65];
	static DfaState st194[65];
	static DfaState st195[65];
	static DfaState st196[65];
	static DfaState st197[65];
	static DfaState st198[65];
	static DfaState st199[65];
	static DfaState st200[65];
	static DfaState st201[65];
	static DfaState st202[65];
	static DfaState st203[65];
	static DfaState st204[65];
	static DfaState st205[65];
	static DfaState st206[65];
	static DfaState st207[65];
	static DfaState st208[65];
	static DfaState st209[65];
	static DfaState st210[65];
	static DfaState st211[65];
	static DfaState st212[65];
	static DfaState st213[65];
	static DfaState st214[65];
	static DfaState st215[65];
	static DfaState st216[65];
	static DfaState st217[65];
	static DfaState st218[65];
	static DfaState st219[65];
	static DfaState st220[65];
	static DfaState st221[65];
	static DfaState st222[65];
	static DfaState st223[65];
	static DfaState st224[65];
	static DfaState st225[65];
	static DfaState st226[65];
	static DfaState st227[65];
	static DfaState st228[65];
	static DfaState st229[65];
	static DfaState st230[65];
	static DfaState st231[65];
	static DfaState st232[65];
	static DfaState st233[65];
	static DfaState st234[65];
	static DfaState st235[65];
	static DfaState st236[65];
	static DfaState st237[65];
	static DfaState st238[65];
	static DfaState st239[65];
	static DfaState st240[65];
	static DfaState st241[65];
	static DfaState st242[65];
	static DfaState st243[65];
	static DfaState st244[65];
	static DfaState st245[65];
	static DfaState st246[65];
	static DfaState st247[65];
	static DfaState st248[65];
	static DfaState st249[65];
	static DfaState st250[65];
	static DfaState st251[65];
	static DfaState st252[65];
	static DfaState st253[65];
	static DfaState st254[65];
	static DfaState st255[65];
	static DfaState st256[65];
	static DfaState st257[65];
	static DfaState st258[65];
	static DfaState st259[65];
	static DfaState st260[65];
	static DfaState st261[65];
	static DfaState st262[65];
	static DfaState st263[65];
	static DfaState st264[65];
	static DfaState st265[65];
	static DfaState st266[65];
	static DfaState st267[65];
	static DfaState st268[65];
	static DfaState st269[65];
	static DfaState st270[65];
	static DfaState st271[65];
	static DfaState st272[65];
	static DfaState st273[65];
	static DfaState st274[65];
	static DfaState st275[65];
	static DfaState st276[65];
	static DfaState st277[65];
	static DfaState st278[65];
	static DfaState st279[65];
	static DfaState st280[65];
	static DfaState st281[65];
	static DfaState st282[65];
	static DfaState st283[65];
	static DfaState st284[65];
	static DfaState st285[65];
	static DfaState st286[65];
	static DfaState st287[65];
	static DfaState st288[65];
	static DfaState st289[65];
	static DfaState st290[65];
	static DfaState st291[65];
	static DfaState st292[65];
	static DfaState st293[65];
	static DfaState st294[65];
	static DfaState st295[65];
	static DfaState st296[65];
	static DfaState st297[65];
	static DfaState st298[65];
	static DfaState st299[65];
	static DfaState st300[65];
	static DfaState st301[65];
	static DfaState st302[65];
	static DfaState st303[65];
	static DfaState st304[65];
	static DfaState st305[65];
	static DfaState st306[65];
	static DfaState st307[65];
	static DfaState st308[65];
	static DfaState st309[65];
	static DfaState st310[65];
	static DfaState st311[65];
	static DfaState st312[65];
	static DfaState st313[65];
	static DfaState st314[65];
	static DfaState st315[65];
	static DfaState st316[65];
	static DfaState st317[65];
	static DfaState st318[65];
	static DfaState st319[65];
	static DfaState st320[65];
	static DfaState st321[5];
	static DfaState st322[5];
	static DfaState st323[5];
	static DfaState st324[5];
	static DfaState st325[5];
	static DfaState st326[5];
	static DfaState st327[5];
	static DfaState st328[5];
	static DfaState st329[5];
	static DfaState st330[5];
	static DfaState st331[5];
	static DfaState st332[5];
	static DfaState st333[7];
	static DfaState st334[7];
	static DfaState st335[7];
	static DfaState st336[7];
	static DfaState st337[7];
	static DfaState st338[7];
	static DfaState st339[7];
	static DfaState st340[7];
	static DfaState st341[6];
	static DfaState st342[6];
	static DfaState st343[6];
	static DfaState st344[6];
	static DfaState st345[6];
	static DfaState st346[6];
	static DfaState st347[6];
	static DfaState st348[6];
	static DfaState st349[4];
	static DfaState st350[4];
	static DfaState st351[4];
	static DfaState st352[4];
	static DfaState *dfa[353];
	static DfaState dfa_base[];
	static unsigned char *b_class_no[];
	static DfaState accepts[354];
	static DLGChar alternatives[354];
	static ANTLRTokenType (JLexer::*actions[141])();
	static unsigned char shift0[257];
	static unsigned char shift1[257];
	static unsigned char shift2[257];
	static unsigned char shift3[257];
	static unsigned char shift4[257];
	static unsigned char shift5[257];
	int ZZSHIFT(int c) { return b_class_no[automaton][1+c]; }
//
// 133MR1 Deprecated feature to allow inclusion of user-defined code in DLG class header
//
#ifdef DLGLexerIncludeFile
#include DLGLexerIncludeFile
#endif
};
typedef ANTLRTokenType (JLexer::*PtrJLexerMemberFunc)();
#endif
