/*
 * JParser: P a r s e r  H e a d e r 
 *
 * Generated from: java.g
 *
 * Terence Parr, Russell Quong, Will Cohen, and Hank Dietz: 1989-2001
 * Parr Research Corporation
 * with Purdue University Electrical Engineering
 * with AHPCRC, University of Minnesota
 * ANTLR Version 1.33MR33
 */

#ifndef JParser_h
#define JParser_h

#ifndef ANTLR_VERSION
#define ANTLR_VERSION 13333
#endif

#ifndef zzTRACE_RULES
#define zzTRACE_RULES
#endif
#include "AParser.h"


#define zzTRACE_RULES
#include "AParser.h"
#include "cccc.h"
#include "cccc_utl.h"
#include "cccc_opt.h"

  // the objects which PCCTS creates for ASTs as the #0 variable etc
// have type "pointer to ASTBase", which means they need to be cast
// to a pointer to my variant of AST if I want to call my AST 
// methods on them
#define MY_AST(X) ( (AST*) X)
class JParser : public ANTLRParser {
public:
	static  const ANTLRChar *tokenName(int tk);
	enum { SET_SIZE = 227 };
protected:
	static const ANTLRChar *_token_tbl[];
private:


ParseStore* ps;
ParseUtility* pu;

void tracein(const char *rulename)  { pu->tracein(rulename,guessing,LT(1)); }
void traceout(const char *rulename)  { pu->traceout(rulename,guessing,LT(1)); }
void syn(
_ANTLRTokenPtr tok, ANTLRChar *egroup, SetWordType *eset,
ANTLRTokenType etok, int k) 
{ 
  pu->syn(tok,egroup,eset,etok,k);
}

string typeCombine(const string& modifiers, const string& name, const string& indir)
{
  string retval;
  if(modifiers.size()>0)
  {
    retval=modifiers+" "+name;
  }
  else
  {
    retval=name;
  }
  if(indir.size()>0)
  {
    retval+=" ";
    retval+=indir;
  }
  return retval;
}

// we have a data member for the language of the parse so
// that we can supply the names of dialects (ansi_c, ansi_c++, mfc_c++ etc)
// for contexts where we wish to apply dialect-specific parsing
// rules
string parse_language;

// Many of the rules below accept string parameters to 
// allow upward passing of attributes.
// Where the calling context does not need to receive
// the attributes, it can use the dummy values defined
// here to save allocating a string locally to satisfy the
// parameter list.
string d1,d2,d3;
bool db;

public:

void init(const string& filename, const string& language)
{ 
  pu=ParseUtility::currentInstance();
  ps=ParseStore::currentInstance();
  
	ANTLRParser::init();
  parse_language=language;
}

  
protected:
	static SetWordType err1[32];
	static SetWordType err2[32];
	static SetWordType err3[32];
	static SetWordType setwd1[227];
	static SetWordType err4[32];
	static SetWordType err5[32];
	static SetWordType setwd2[227];
	static SetWordType err6[32];
	static SetWordType err7[32];
	static SetWordType err8[32];
	static SetWordType err9[32];
	static SetWordType setwd3[227];
	static SetWordType err10[32];
	static SetWordType err11[32];
	static SetWordType err12[32];
	static SetWordType err13[32];
	static SetWordType err14[32];
	static SetWordType err15[32];
	static SetWordType setwd4[227];
	static SetWordType err16[32];
	static SetWordType err17[32];
	static SetWordType setwd5[227];
	static SetWordType err18[32];
	static SetWordType err19[32];
	static SetWordType err20[32];
	static SetWordType err21[32];
	static SetWordType err22[32];
	static SetWordType err23[32];
	static SetWordType err24[32];
	static SetWordType err25[32];
	static SetWordType setwd6[227];
	static SetWordType err26[32];
	static SetWordType err27[32];
	static SetWordType err28[32];
	static SetWordType setwd7[227];
	static SetWordType err29[32];
	static SetWordType err30[32];
	static SetWordType err31[32];
	static SetWordType setwd8[227];
	static SetWordType err32[32];
	static SetWordType setwd9[227];
	static SetWordType err33[32];
	static SetWordType err34[32];
	static SetWordType err35[32];
	static SetWordType err36[32];
	static SetWordType setwd10[227];
	static SetWordType err37[32];
	static SetWordType setwd11[227];
	static SetWordType err38[32];
	static SetWordType err39[32];
	static SetWordType err40[32];
	static SetWordType setwd12[227];
	static SetWordType err41[32];
	static SetWordType err42[32];
	static SetWordType err43[32];
	static SetWordType setwd13[227];
	static SetWordType err44[32];
	static SetWordType err45[32];
	static SetWordType err46[32];
	static SetWordType err47[32];
	static SetWordType err48[32];
	static SetWordType setwd14[227];
	static SetWordType err49[32];
	static SetWordType err50[32];
	static SetWordType err51[32];
	static SetWordType setwd15[227];
	static SetWordType setwd16[227];
	static SetWordType err52[32];
	static SetWordType err53[32];
	static SetWordType err54[32];
	static SetWordType err55[32];
	static SetWordType err56[32];
	static SetWordType setwd17[227];
	static SetWordType err57[32];
	static SetWordType err58[32];
	static SetWordType err59[32];
	static SetWordType err60[32];
	static SetWordType setwd18[227];
	static SetWordType err61[32];
	static SetWordType err62[32];
	static SetWordType err63[32];
	static SetWordType err64[32];
	static SetWordType err65[32];
	static SetWordType setwd19[227];
	static SetWordType err66[32];
	static SetWordType err67[32];
	static SetWordType err68[32];
	static SetWordType err69[32];
	static SetWordType err70[32];
	static SetWordType setwd20[227];
	static SetWordType err71[32];
	static SetWordType err72[32];
	static SetWordType err73[32];
	static SetWordType err74[32];
	static SetWordType err75[32];
	static SetWordType setwd21[227];
private:
	void zzdflthandlers( int _signal, int *_retsignal );

public:
	JParser(ANTLRTokenBuffer *input);
	void compilationUnit(void);
	void packageDefinition(string& scope);
	void importDefinition(void);
	void typeDefinition(string& parentScope);
	void declaration(void);
	void modifiers(Visibility& v);
	void typeParameters(void);
	void typeSpec(void);
	void classTypeSpec(void);
	void builtInTypeSpec(void);
	void type(void);
	void builtInType(void);
	void identifier(void);
	void typeSpec2(string& typeString,bool& isBuiltIn);
	void classTypeSpec2(string& typeString);
	void builtInTypeSpec2(string& typeString);
	void identifier2(string& scope);
	void identifierStar(void);
	void modifier(Visibility& v);
	void classDefinition(string& parentScope);
	void superClassClause(const string& className);
	void interfaceDefinition(const string& parentScope);
	void classBlock(const string& className);
	void interfaceExtends(const string& className);
	void implementsClause(const std::string& className);
	void moreSuperclassNames(const string& className,const string& inheritType);
	void field(const string& className);
	void typedDeclaration(const string& className,const string& typeName,bool isBuiltIn,Visibility v,int startLine);
	void methodDefinition(const string& className,const string& returnType,bool rtIsBuiltIn,Visibility v,int startLine);
	void variableDefinitions(const string& className,const string& returnType,bool rtIsBuiltIn,Visibility v,int startLine);
	void variableDeclarator(void);
	void declaratorBrackets(void);
	void varInitializer(void);
	void arrayInitializer(void);
	void initializer(void);
	void ctorDefinition(const string& className,Visibility v);
	void ctorHead(string& paramList,const string& className,Visibility v);
	void throwsClause(void);
	void returnTypeBrackersOnEndOfMethodHead(void);
	void parameterDeclarationList(// a string in which we accumulate a string of all parameters
		string& paramList,// the name of the owner class for the method
	 	const string& clientName,// visibility of the method
	 	const Visibility& v);
	void parameterDeclaration(// a string in which we accumulate a string of all parameters
		string& paramList,// the name of the owner class for the method
	 	const string& clientName,// visibility of the method
	 	const Visibility& v,// is this rule being used from a parameter list (in which case
		// we want to do record_userel_extent) or from a syntacticly similar
		// catch statement,which is buried in the implementation of a method 
		// and does not interest us
		bool inParameterList);
	void parameterDeclaratorBrackets(string& bracks);
	void parameterModifier(string& paramList);
	void compoundStatement(void);
	void statement(void);
	void ifStatement(void);
	void forStatement(void);
	void whileStatement(void);
	void doWhileStatement(void);
	void breakStatement(void);
	void continueStatement(void);
	void returnStatement(void);
	void switchStatement(void);
	void throwStatement(void);
	void syncStatement(void);
	void emptyStatement(void);
	void optElseClause(void);
	void casesGroup(void);
	void cases(void);
	void optMoreCases(void);
	void aCase(void);
	void caseSList(void);
	void forInit(void);
	void forCond(void);
	void forIter(void);
	void tryBlock(void);
	void handler(void);
	void expression(void);
	void expressionList(void);
	void assignmentExpression(void);
	void conditionalExpression(void);
	void logicalOrExpression(void);
	void logicalAndExpression(void);
	void inclusiveOrExpression(void);
	void exclusiveOrExpression(void);
	void andExpression(void);
	void equalityExpression(void);
	void relationalPredicate(void);
	void relationalExpression(void);
	void shiftExpression(void);
	void additiveExpression(void);
	void multiplicativeExpression(void);
	void unaryExpression(void);
	void unaryExpressionNotPlusMinus(void);
	void postfixExpression(void);
	void primaryExpression(void);
	void newExpression(void);
	void argList(void);
	void newArrayDeclarator(void);
	void constant(void);
};

#endif /* JParser_h */
